#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <semaphore.h>
#include <sys/mman.h>
#include <string.h>

#include <signal.h>
#include <sys/wait.h>

#define checkError(expr,userMsg) \
    do {\
        if (!(expr)) {\
            perror(userMsg); \
            exit(EXIT_FAILURE);\
        }\
    } while (0)

#define RD_END  (0)
#define WR_END  (1)

int main(int argc, char** argv) {

    checkError(argc == 2, "args");

    int cld2par[2];
    checkError(pipe(cld2par) != -1, "...");

    pid_t childPid = fork();
    checkError(childPid != -1, "fork");

    if (childPid == 0) {

        close(cld2par[RD_END]);

        checkError(dup2(cld2par[WR_END], STDOUT_FILENO) != -1, "dup2");
        checkError(execlp("cat", "cat", argv[1], NULL) != -1, "execlp");
    }

    close(cld2par[WR_END]);

    FILE* in = fdopen(cld2par[RD_END], "r");
    checkError(in != NULL, "fdopen");

    int brLinija = 0;
    char* line = NULL;
    size_t lineLen = 0;
    while (getline(&line, &lineLen, in) != -1) {

        brLinija++;
    }

    free(line);

    checkError(wait(NULL) != -1, "...");
    printf("Broj linija: %d\n", brLinija);

    fclose(in);

    exit(EXIT_SUCCESS);
}