#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <semaphore.h>
#include <sys/mman.h>
#include <string.h>

#include <signal.h>

#define checkError(expr,userMsg) \
    do {\
        if (!(expr)) {\
            perror(userMsg); \
            exit(EXIT_FAILURE);\
        }\
    } while (0)

int usr1 = 0;
int usr2 = 0;
int run = 1;

void sigHandler(int signum) {

    switch (signum) {
        case SIGUSR1:
            usr1 = 1;
            break;
        case SIGUSR2:
            usr2 = 1;
            break;
        case SIGTERM:
            run = 0;
            break;
    }
}

int main(int argc, char** argv) {

    checkError(signal(SIGUSR1, sigHandler) != SIG_ERR, "signal");
    checkError(signal(SIGUSR2, sigHandler) != SIG_ERR, "signal");
    checkError(signal(SIGTERM, sigHandler) != SIG_ERR, "signal");

    fprintf(stderr, "%d\n", getpid());

    do {

        pause();

        if (usr1) {
            printf("SIGUSR1\n");
            usr1 = 0;
        }

        if (usr2) {
            printf("SIGUSR2\n");
            usr2 = 0;
        }

    } while (run);

    exit(EXIT_SUCCESS);
}